; This program is free software. It comes without any warranty, to
; the extent permitted by applicable law. You can redistribute it
; and/or modify it under the terms of the Do What The Fuck You Want
; To Public License, Version 2, as published by Sam Hocevar. See
; http://sam.zoy.org/wtfpl/COPYING for more details.

;====== Hex Editor =============================================================	
; To-do:
; - Find
; - fix goto bug -- Fixed?
; - Start/End

hexEditor:
;------ Set up Editor ----------------------------------------------------------	
	ld	hl, editTemps
	ld	b, editTempsLen
	xor	a
	call	clearMem
	ld	(iy+EditorFlags), 0
	res	appAutoScroll, (iy+appFlags)
	
;------ Edit Loop --------------------------------------------------------------
; Draw screen
dispScreen:
	B_CALL(_ClrScrnFull)
	; Block start location
	ld	hl, 0000h
	ld	(curRow), hl
	ld	a, (editLocation+1)
	cp	40h
	jr	c, +_
	cp	80h
	jr	nc, +_
	ld	a, (editPage)
	call	dispByte
	ld	a, ':' ;
	B_CALL(_PutC)
_:	; show location
	ld	a, 03
	ld	(curCol), a
	ld	hl, (editLocation)
	ld	de, (editOffset)
	add	hl, de
	ld	a, h
	call	dispByte
	ld	a, l
	call	dispByte
	;ld	a, ':' ;
	;B_CALL(_PutC)
	
	; indicator for rel mode
	ld	a, (editOffset)
	or	a
	jr	nz, +_
	ld	a, (editOffset+1)
	or	a
	jr	z, dispHexNotRel
_:	ld	a, 9
	ld	(curCol), a
	ld	a, 'R'
	b_call(_PutC)
dispHexNotRel:	
	ld	hl, (editLocation)
	ld	c, 7
	ld	de, 0001h
dispHexLoop:
	ld	(curRow), de
	inc	e
	ld	b, 4
rtmp1:	call	getByte;ld	a, (hl)
	inc	hl
	call	dispByte
	ld	a, ' '
	push	hl
	push	de
	push	bc
	B_CALL(_PutC)
	pop	bc
	pop	de
	pop	hl
	djnz	rtmp1
	dec	c
	jr	nz, dispHexLoop
	; Disp text data
	ld	hl, (editLocation)
	ld	c, 7
	ld	de, 0C01h
dispTextLoop:
	ld	(curRow), de
	inc	e
	ld	b, 4
rtmp2:	call	getByte;ld	a, (hl)
	inc	hl
	cp	Lenter
	jr	nz, notLenter
	ld	a, ' '
notLenter:
	B_CALL(_PutC)
	djnz	rtmp2
	dec	c
	jr	nz, dispTextLoop
; Display cursor
dispCursor:
	ld	hl, 0C00h
	ld	(curRow), hl
	call	getActualLocation
	ld	de, (editOffset)
	add	hl, de
	ld	a, h
	call	dispByte
	ld	a, l
	call	dispByte ;
	ld	(iy+shiftFlags), 00000000b
	bit	hexTexsMode, (iy+EditorFlags)
	jr	nz, rtmp3
	ld	a, (xLoc)
	ld	h, a
	ld	e, 3
	call	multHbyE
	ld	h, l
	ld	a, (yLoc)
	inc	a
	ld	l, a
	ld	(curRow), hl
	jr	dispCursorDone
rtmp3:	ld	a, (xLoc)
	add	a, 12
	ld	h, a
	ld	a, (yLoc)
	inc	a
	ld	l, a
	ld	(curRow), hl
dispCursorDone:

; Key loop
keyLoop:
	B_CALL(_CursorOn)
	B_CALL(_GetKey)
	push	af
	B_CALL(_CursorOff)
	pop	af
	cp	kUp
	jr	z, moveUp
	cp	kDown
	jr	z, moveDown
	cp	kLeft
	jp	z, moveLeft
	cp	kRight
	jp	z, moveRight
	cp	kGraph
	jp	z, moveForward
	cp	kTrace
	jp	z, moveBackward
	cp	kLParen
	jp	z, shiftBackward
	cp	kRParen
	jp	z, shiftForward
	cp	kAdd
	jp	z, jumpForward
	cp	kSub
	jp	z, jumpBackward
	cp	kMul
	jp	z, jumpBigForward
	cp	kDiv
	jp	z, jumpBigBackward
	cp	kTan
	jp	z, gotoAddress
	cp	kMode
	jp	z, toggleMode
	cp	kEnter
	jp	z, editByte
	cp	kStore
	jp	z, editWriteFlash
	cp	kVars
	jp	z, ASCIIchart
	ld	hl, mEdit
	cp	kClear
	jp	z, menu;mainMenu
	;ret	z
	cp	kWindow
	jp	z, dispScreen
	cp	kYEqu
	jp	z, hexEditMenu
	cp	kZoom
	jp	z, hexEditEditPage
	jr	keyLoop

moveUp:
	ld	a, (yLoc)
	or	a
	jr	z, rtmp4
	dec	a
	ld	(yLoc), a
	jp	dispCursor
rtmp4:	ld	hl, (editLocation)
	dec	hl
	dec	hl
	dec	hl
	dec	hl
	ld	(editLocation), hl
	jp	dispScreen
	
moveDown:
	ld	a, (yLoc)
	cp	6
	jr	z, rtmp5
	inc	a
	ld	(yLoc), a
	jp	dispCursor
rtmp5:	ld	hl, (editLocation)
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	ld	(editLocation), hl
	jp	dispScreen
	
moveLeft:
	ld	a, (xLoc)
	or	a
	jr	z, rtmp6
	dec	a
	ld	(xLoc), a
	jp	dispCursor
rtmp6:	ld	a, (yLoc)
	or	a
	jr	z, rtmp7
	ld	a, 3
	ld	(xLoc), a
	ld	a, (yLoc)
	dec	a
	ld	(yLoc), a
	jp	dispCursor
rtmp7:	ld	hl, (editLocation)
	dec	hl
	ld	(editLocation), hl
	jp	dispScreen

moveRight:
	ld	b, 0
moveRightRefresh:
	ld	a, (xLoc)
	cp	3
	jr	z, rtmp8
	inc	a
	ld	(xLoc), a
condRefresh:
	ld	a, b
	or	a
	jp	z, dispCursor
	jp	dispScreen
rtmp8:	ld	a, (yLoc)
	cp	6
	jr	z, rtmp9
	xor	a
	ld	(xLoc), a
	ld	a, (yLoc)
	inc	a
	ld	(yLoc), a
	jr	condRefresh
rtmp9:	ld	hl, (editLocation)
	inc	hl
	ld	(editLocation), hl
	jp	dispScreen

moveForward:
	ld	a, (yLoc)
	cp	3
	jr	nc, rtmp10
	add	a, 4
	ld	(yLoc), a
	jp	dispCursor
rtmp10:	cp	6
	jr	z, moveForwardStupidUselessLabel
	ld	a, 6
	ld	(yLoc), a
	ld	a, 3
	ld	(xLoc), a
	jp	dispCursor
moveForwardStupidUselessLabel:
	ld	a, (xLoc)
	cp	3
	jr	nz, rtmp10
	ld	hl, (editLocation)
	ld	de, 16
	add	hl, de
	ld	(editLocation), hl
	jp	dispScreen

moveBackward:
	ld	a, (yLoc)
	cp	4
	jr	c, rtmp11
	sub	4
	ld	(yLoc), a
	jp	dispCursor
rtmp11:	or	a
	jr	z, moveBackwardNoImNotCallingThisOneStupidToo
	xor	a
	ld	(xLoc), a
	ld	(yLoc), a
	jp	dispCursor
moveBackwardNoImNotCallingThisOneStupidToo:
	ld	a, (xLoc)
	or	a
	jr	nz, rtmp11
	ld	hl, (editLocation)
	ld	de, 16
	or	a
	sbc	hl, de
	ld	(editLocation), hl
	jp	dispScreen

shiftForward:
	ld	hl, (editLocation)
	inc	hl
	ld	(editLocation), hl
	jp	dispScreen
	
shiftBackward:
	ld	hl, (editLocation)
	dec	hl
	ld	(editLocation), hl
	jp	dispScreen

jumpForward:
	ld	hl, (editLocation)
	inc	h
	ld	(editLocation), hl
	jp	dispScreen

jumpBackward:
	ld	hl, (editLocation)
	dec	h
	ld	(editLocation), hl
	jp	dispScreen

jumpBigForward:
	ld	hl, (editLocation)
	ld	a, h
	add	a, 10h
	ld	h, a
	ld	(editLocation), hl
	jp	dispScreen

jumpBigBackward:
	ld	hl, (editLocation)
	ld	a, h
	sub	10h
	ld	h, a
	ld	(editLocation), hl
	jp	dispScreen

;------ Not shift commands -----------------------------------------------------
toggleMode:
	bit	hexTexsMode, (iy+EditorFlags)
	jr	z, rtmp12
	res	hexTexsMode, (iy+EditorFlags)
	jp	dispCursor
rtmp12:	set	hexTexsMode, (iy+EditorFlags)
	jp	dispCursor

hexEditEditPage:
	ld	hl, 0000h
	ld	(curRow), hl
	call	getHexByte
	ld	(editPage), a
	jp	dispScreen

editByte:
	bit	hexTexsMode, (iy+EditorFlags)
	jr	nz, rtmp13
	call	getActualLocation
	push	hl
	call	getHexByte
	pop	hl
	call	putByte;ld	(hl), a
	ld	b, 1
	jp	moveRightRefresh
rtmp13:
	B_CALL(_CursorOn)
	B_CALL(_getkey)
	push	af
	B_CALL(_CursorOff)
	pop	af
	;B_CALL(_ConvKeyToTok)
	b_call(4A02h)
	push	de
	push	de
	ld	hl, 0
	add	hl, sp
	ld	a, d
	or	a
	jr	z, rtmp14
	inc	hl
rtmp14:	B_CALL(_GET_TOK_STRNG)
	pop	hl
	pop	hl
	call	getActualLocation
	ld	a, (OP3)
	call	putByte;ld	(hl), a
;	B_CALL(_PutC)
	ld	b, 1
	jp	moveRightRefresh;dispScreen

editWriteFlash:
	B_CALL(_ClrScrnFull)
	b_call(_HomeUp)
	call	getActualLocation
	ld	de, (editOffset)
	add	hl, de	
	ld	a, h
	call	dispByte
	ld	a, l
	call	dispByte
	ld	a, 32
	b_call(_PutC)
	ld	a, 28h
	b_call(_PutC)
	; physical location
	call	getActualLocation
	ld	a, h
	call	dispByte
	ld	a, l
	call	dispByte
	ld	a, 29h
	b_call(_PutC)
	b_call(_NewLine)
	ld	hl, strEditWriteByte
	b_call(_PutS)
	call	getHexByte
	push	af
	b_call(_NewLine)
	ld	hl, strWarning
	b_call(_PutS)
	b_call(_NewLine)
	b_call(_GetKey)
	cp	kEnter
	jr	z, +_
	pop	af
	jp	dispScreen
_:
	call	getActualLocation
	pop	af
	ld	b, a
	ld	a, (editPage)
	ld	c, a
	call	writeFlashByte
	ld	hl, strDone
	jr	z, +_
	ld	hl, strFailed
_:	
	b_call(_PutS)
	b_call(_GetKey)
	jp	dispScreen

getActualLocation:
	ld	hl, (editLocation)
	ld	a, (yLoc)
	sla	a
	sla	a
	ld	b, a
	ld	a, (xLoc)
	add	a, b
	ld	d, 0
	ld	e, a
	add	hl, de	
	ret

gotoAddress:
;	B_CALL_(ClrScrn)
	ld	hl, 0C00h ; 0
	ld	(curRow), hl
;	ld	hl, gotoAddressText
;	call	PutS
	call	getHexByte
	ld	h, a
	call	getHexByte
	ld	l, a
	ld	de, (editOffset)
	or	a
	sbc	hl, de	; note: this IS correct
	ld	(editLocation), hl
	jp	dispScreen

hexEditMenu:
	jp	keyLoop
;	B_CALL_(ClrScrn)
;	ld	hl, 0
;	ld	(curRow), hl

;------ ASCII Chart ------------------------------------------------------------
ASCIIchart:
	xor	a
	ld	(chartX), a
	ld	(chartY), a
	ld	a, 32
	ld	(chartIndex), a
drawChart:
	B_CALL(_ClrScrnFull)
	ld	hl, 0
	ld	(curRow), hl
	ld	hl, ASCIIchartText
	call	PutS
	ld	b, 111
	ld	a, (chartIndex)
drawChartLoop:
	cp	Lenter
	jr	nz, rtmp16
	ld	a, ' '
	B_CALL(_PutC)
	ld	a, Lenter+1
	dec	b
rtmp16:	B_CALL(_PutC)
	inc	a
	djnz	drawChartLoop
	B_CALL(_PutMap)
chartCursor:
	ld	hl, (chartY)
	inc	l
	ld	(curRow), hl
	B_CALL(_CursorOn)
rtmp17:	;B_CALL(_getkey)
	B_CALL(_GetKey)
	push	af
	B_CALL(_CursorOff)
	pop	af
	cp	kUp
	jr	z, aMoveUp
	cp	kDown
	jr	z, aMoveDown
	cp	kLeft
	jr	z, aMoveLeft
	cp	kRight
	jr	z, aMoveRight
	cp	kClear
	jp	z, dispScreen
	cp	kEnter
	jr	z, ASCIIwrite
	jr	rtmp17
aMoveUp:
	ld	a, (chartY)
	or	a
	jr	z, rtmp18
	dec	a
	ld	(chartY), a
	jr	chartCursor
rtmp18:	ld	a, (chartIndex)
	sub	16
	ld	(chartIndex), a
	jr	drawChart
aMoveDown:
	ld	a, (chartY)
	cp	6
	jr	z, rtmp19
	inc	a
	ld	(chartY), a
	jr	chartCursor
rtmp19:	ld	a, (chartIndex)
	add	a, 16
	ld	(chartIndex), a
	jp	drawChart
aMoveLeft:
	ld	a, (chartX)
	or	a
	jr	z, chartCursor
	dec	a
	ld	(chartX), a
	jr	chartCursor
aMoveRight:
	ld	a, (chartX)
	cp	15
	jr	z, chartCursor
	inc	a
	ld	(chartX), a
	jr	chartCursor
ASCIIwrite:
	ld	a, (chartY)
	sla	a
	sla	a
	sla	a
	sla	a
	ld	b, a
	ld	a, (chartX)
	ld	c, a
	ld	a, (chartIndex)
	add	a, b
	add	a, c
	push	af
	call	getActualLocation
	pop	af
	call	putByte;ld	(hl), a
	jp	dispScreen
	

;------ Memory stuff -----------------------------------------------------------
getByte:
; Gets a byte from (editPage).  Does not wrap.
; Input:
;  - HL: Address
; Output:
;  - A: Byte
; Kills no register
	push	bc
	ld	c, 6
	in	b, (c)
	ld	a, (editPage)
	out	(c), a
	ld	a, (hl)
	out	(c), b
	pop	bc
	ret

putByte:
; Writes a byte to page (editPage).  Does not wrap.
; Input:
;  - HL: Address
;  - A: Byte
	push	bc
	ld	c, 6
	in	b, (c)
	push	bc
	ld	b, a
	ld	a, (editPage)
	out	(c), a
	ld	(hl), b
	pop	bc
	out	(c), b
	pop	bc
	ret