; ==============================================================================
; Flash Editor
; This program is free software. It comes without any warranty, to
; the extent permitted by applicable law. You can redistribute it
; and/or modify it under the terms of the Do What The Fuck You Want
; To Public License, Version 2, as published by Sam Hocevar. See
; http://sam.zoy.org/wtfpl/COPYING for more details. 

; You will need to provide the flash unlock code youself if you wish to
; reassemble this.

; ===== Equates ================================================================
.nolist
#include "ti83plus.txt"
.list

chNewLine	.equ	0D6h

;spaddr		.equ	appBackUpScreen
inputerFlags	.equ	Asm_Flag1
secondNibble	.equ	0

ramBufVAT	.equ	appBackUpScreen
ramBufAddr	.equ	ramBufVAT+2
ramBufName	.equ	ramBufAddr+2
srcFlashAddr	.equ	ramBufName+10 ; super little-endian
srcFlashPage	.equ	srcFlashAddr+2
srcFlashLen	.equ	srcFlashPage+1
destRAMAddr	.equ	srcFlashLen+2
destRAMPage	.equ	destRAMAddr+2

editOffset	.equ	destRAMPage+1	; physical+offset=logical; physical=logical-offset
editLocation	.equ	editOffset+2	; physical address
editPage	.equ	editLocation+2
editSize	.equ	editPage+1
editStart	.equ	editSize+2
editEnd		.equ	editStart+2
editTemps	.equ	editEnd+2
editTempsLen	.equ	10
xLoc		.equ	editTemps
yLoc		.equ	xLoc+1
chartIndex	.equ	yLoc+1
chartY		.equ	chartIndex+1
chartX		.equ	chartY+1
;chartX		.equ	chartIndex+1
;chartY		.equ	chartX+1
maxNameLength	.equ	editTemps
lastCurCol	.equ	maxNameLength+1

EditorFlags	.equ	asm_Flag1
; Editor Type 1 flags
hexTexsMode	.equ	1
prgmFlags	.equ	asm_Flag1
enableLowercase	.equ	2
flashWriteMode	.equ	7

numberOfLetters	.equ	asm_Flag2


;====== Header =================================================================
	.org	$9D93
	.db	t2ByteTok, tAsmCmp


;====== Init ===================================================================
	call	UnlockFlash
	;ld	(spaddr), sp
	pop	hl
	push	hl
	ld	(spaddr), hl
	in	a, (6)
	ld	(sppage), a
	res	indicRun, (iy+indicFlags)
	; init some stuff
	ld	hl, ramBufVAT
	ld	b, 50
	xor	a
	call	clearMem

mainMenu:
	set	appAutoScroll, (iy+appFlags)
	ld	hl, mMainMenu
	jp	menu

;====== Editor Stuff ===========================================================
createRAMBuffer:
	B_CALL(_ClrScrnFull)
	b_call(_HomeUp)
	ld	a, (ramBufAddr+1)
	or	a
	jr	z, bufNotSet
	ld	hl, strAddress
	b_call(_PutS)
	ld	hl, (ramBufAddr)
	ld	a, h
	call	dispByte
	ld	a, l
	call	dispByte
	b_call(_NewLine)
	ld	hl, strVarName
	b_call(_PutS)
	ld	hl, ramBufName
	b_call(_PutS)
	b_call(_NewLine)
	ld	hl, strEnterToModify
	b_call(_PutS)
	b_call(_GetKey)
	cp	kEnter
	ld	hl, mEditOptions
	jp	nz, menu
bufNotSet:
	; disp free mem
	ld	hl, strFreeMem
	b_call(_PutS)
	b_call(_MemChk)
	ld	a, h
	call	dispByte
	ld	a, l
	call	dispByte
	b_call(_NewLine)
	; get var name
	ld	hl, strVarName
	b_call(_PutS)
	ld	ix, OP1+1
	ld	a, 8
	ld	(maxNameLength), a
	set	enableLowercase, (iy+prgmFlags)
	call	getName
	ld	a, AppVarObj
	ld	(OP1), a
	b_call(_ChkFindSym)
	jr	nc, createRAMBufVarExists
	b_call(_NewLine)
	ld	hl, strLength
	b_call(_PutS)
	call	getHexByte
	ld	h, a
	call	getHexByte
	ld	l, a
	push	hl
	ld	hl, OP1+1
	ld	de, ramBufName
	ld	bc, 8
	ldir
	pop	hl
	b_call(_CreateAppVar)
	ld	(ramBufVAT), hl
	ld	(ramBufAddr), de
	b_call(_NewLine)
	ld	hl, strAddress
	b_call(_PutS)
	ld	hl, (ramBufAddr)
	ld	a, h
	call	dispByte
	ld	a, l
	call	dispByte
	b_call(_GetKey)
	ld	hl, mEditOptions
	jp	menu
createRAMBufVarExists:
	xor	a
	cp	b
	jr	nz, createRAMBufArchived
	push	de
	push	hl
	b_call(_NewLine)
	ld	hl, strVarExists
	b_call(_PutS)
	pop	hl
	push	hl
	ld	a, d
	call	dispByte
	ld	a, e
	call	dispByte
	b_call(_GetKey)
	pop	hl
	pop	de
	cp	kEnter
	jr	nz, +_
	ld	(ramBufVAT), hl
	ld	(ramBufAddr), de
	ld	hl, OP1+1
	ld	de, ramBufName
	ld	bc, 8
	ldir
_:	ld	hl, mEditOptions
	jp	menu
createRAMBufArchived:
	b_call(_NewLine)
	ld	hl, strArchived
	b_call(_PutS)
	b_call(_GetKey)
	ld	hl, mEditOptions
	jp	menu


;------ Settings ---------------------------------------------------------------
editSetOffset:
	ld	hl, strSetOffset
	ld	de, editOffset
	call	editVal16
	jr	goEditOptions
;editSetStart:
;	ld	hl, strSetStart
;	ld	de, editStart
;	call	editVal16
;	jr	goEditOptions
;editSetEnd:
;	ld	hl, strSetEnd
;	ld	de, editEnd
;	call	editVal16
goEditOptions:
	ld	hl, mEditOptions
	jp	menu
editSetPage:
	b_call(_ClrScrnFull)
	b_call(_HomeUp)
	ld	hl, strSetPage
	b_call(_PutS)
	ld	a, (editPage)
	call	dispByte
	b_call(_NewLine)
	ld	hl, strNewValue
	b_call(_PutS)
	call	getHexByte
	ld	(editPage), a
	jr	goEditOptions

editVal16:
; Inputs:
;  - HL: Pointer to description string
;  - DE: Pointer to value
	push	de
	push	hl
	b_call(_ClrScrnFull)
	b_call(_HomeUp)
	pop	hl
	b_call(_PutS)
	pop	de
	push	de
	ld	a, (de)
	ld	l, a
	inc	de
	ld	a, (de)
	call	dispByte
	ld	a, l
	call	dispByte
	b_call(_NewLine)
	ld	hl, strNewValue
	b_call(_PutS)
	call	getHexByte
	push	af
	call	getHexByte
	pop	bc
	pop	hl
	ld	(hl), a
	inc	hl
	ld	(hl), b
	ret


;------ Block Move -------------------------------------------------------------
blockMove:
	B_CALL(_ClrScrnFull)
	b_call(_HomeUp)
	ld	hl, strRegHL
	b_call(_PutS)
	call	getHexByte
	ld	h, a
	call	getHexByte
	ld	l, a
	push	hl
	b_call(_NewLine)
	ld	hl, strRegDE
	b_call(_PutS)
	call	getHexByte
	ld	h, a
	call	getHexByte
	ld	l, a
	push	hl
	b_call(_NewLine)
	ld	hl, strRegBC
	b_call(_PutS)
	call	getHexByte
	ld	h, a
	call	getHexByte
	ld	l, a
	push	hl
	
;	ld	(editTemps), sp
;	ld	hl, (editTemps)
;	b_call(_DispHL)
;	b_call(_GetKey)
	
	ld	hl, mChooseInstr
	jp	menu
blockLdir:
	
;	ld	hl, 0
;	add	hl, sp
;	b_call(_DispHL)
;	b_call(_GetKey)
	
;	ld	sp, (editTemps)
	
	pop	bc
	pop	de
	pop	hl
	ld	a, (editPage)
	out	(6), a
	ldir
	jr	blockReturn
blockLddr:
	pop	bc
	pop	de
	pop	hl
	ld	a, (editPage)
	out	(6), a
	lddr
blockReturn:
	ld	hl, mEdit
	jp	menu
abortBlockMove:
	pop	af
	pop	af
	pop	af
	jr	blockReturn


;====== ========================================================================
; There was a logic behind this code at one point.  Really!
writeFlash:
	set	flashWriteMode, (iy+prgmFlags)
	set	appAutoScroll, (iy+appFlags)
	B_CALL(_ClrScrnFull)
	b_call(_HomeUp)
	ld	hl, strWriteFlashInfo
	b_call(_PutS)
	b_call(_NewLine)
	jr	copyWriteCombinedThingy
copyFlash:
	res	flashWriteMode, (iy+prgmFlags)
	set	appAutoScroll, (iy+appFlags)
	B_CALL(_ClrScrnFull)
	b_call(_HomeUp)
	ld	hl, strCopyFlashInfo
	b_call(_PutS)
copyWriteCombinedThingy:
	ld	hl, strCopyInfo
	b_call(_PutS)
;	ld	hl, strSource
;	b_call(_PutS)
	b_call(_NewLine)
	call	copyUI
	b_call(_NewLine)
	ld	hl, strWorking
	b_call(_PutS)
	; copy!
	di
;	xor	a
;	jr	z, $
	pop	hl
	pop	bc
	ld	c, 6
	ld	de, 8000h
	exx
	pop	ix
	pop	hl
	pop	bc
	ld	e, 0
	ld	c, 6
copyLoop:
; HL: Address; B: Page; C: Port 6; IX: Bytes to write; DE: Temp
	out	(c), b
	ld	a, (hl)
	exx
	out	(c), b
	ld	(hl), a
	bit	flashWriteMode, (iy+prgmFlags)
	jr	z, +_
	push	bc
	ld	b, a
	;call	nz, writeFlashByteRaw
	call	writeFlashByteRaw
	jr	nz, flashWriteFailed
	pop	bc
_:	; check wrap for dest
	inc	hl
	or	a
	sbc	hl, de
	add	hl, de
	jr	nz, copyNoWrapDest
	inc	b
	ld	h, 40h
copyNoWrapDest:
	; wrap src
	exx
	inc	hl
	ld	d, 80h
	or	a
	sbc	hl, de
	add	hl, de
	jr	nz, copyNoWrapSrc
	inc	b
	ld	h, 40h
copyNoWrapSrc:
	dec	ix
	ld	d, 0
	xor	a
	cp	ixh
	jr	nz, copyLoop
	cp	ixl
	jr	nz, copyLoop
	ei
	ld	hl, strDone
	b_call(_PutS)
_:	b_call(_GetKey)
	ld	hl, mMainMenu
	jp	menu
flashWriteFailed:
	ei
	push	hl
	ld	hl, strFailed
	b_call(_PutS)
	pop	hl
	pop	bc
	call	dispByte
	ld	a, ':'
	b_call(_PutC)
	ld	a, h
	call	dispByte
	ld	a, l
	call	dispByte
	jr	-_
	
copyUI:
	pop	hl
	ld	(srcFlashAddr), hl
	;
	ld	hl, strSource
	b_call(_PutS)
	; Page
	b_call(_NewLine)
	ld	hl, strCopyFlashSourcePage
	b_call(_PutS)
	call	getHexByte
	push	af
	; Address
	b_call(_NewLine)
	ld	hl, strCopyFlashSourceAddress
	b_call(_PutS)
	call	getHexByte
	ld	h, a
	call	getHexByte
	ld	l, a
	push	hl
	; Size
	b_call(_NewLine)
	ld	hl, strCopyFlashSourceLength
	b_call(_PutS)
	call	getHexByte
	ld	h, a
	call	getHexByte
	ld	l, a
	push	hl
	; Dest
	b_call(_NewLine)
	ld	hl, strDest
	b_call(_PutS)
	; Page
	b_call(_NewLine)
	ld	hl, strCopyFlashSourcePage
	b_call(_PutS)
	call	getHexByte
	push	af
	; Address
	b_call(_NewLine)
	ld	hl, strCopyFlashSourceAddress
	b_call(_PutS)
	call	getHexByte
	ld	h, a
	call	getHexByte
	ld	l, a
	push	hl

	b_call(_NewLine)
	ld	hl, strWarning
	b_call(_PutS)
	b_call(_GetKey)
	cp	kEnter
	jr	nz, +_
	ld	hl, (srcFlashAddr)
	jp	(hl)
_:
	pop	hl
	pop	hl
	pop	hl
	pop	hl
	pop	hl
	ld	hl, mMainMenu
	jp	nz, menu
	
	
;====== Erase Flash ============================================================
eraseFlash:
	set	appAutoScroll, (iy+appFlags)
	B_CALL(_ClrScrnFull)
	b_call(_HomeUp)
	ld	hl, strEraseFlashInfo
	b_call(_PutS)
	; Page
	b_call(_NewLine)
	ld	hl, strCopyFlashSourcePage
	b_call(_PutS)
	call	getHexByte
	push	af
	; Address
	b_call(_NewLine)
	ld	hl, strCopyFlashSourceAddress
	b_call(_PutS)
	call	getHexByte
	ld	h, a
	call	getHexByte
	ld	l, a
	push	hl
	b_call(_NewLine)
	ld	hl, strWarning
	b_call(_PutS)
	b_call(_NewLine)
	b_call(_GetKey)
	cp	kEnter
	jp	z, +_
	pop	af
	pop	af
	ld	hl, mMainMenu
	jp	menu
_:
	ld	hl, strWorking
	b_call(_PutS)
	pop	hl
	pop	af
	out	(6), a
	call	eraseSectorRaw
	ld	hl, strDone
	jr	nz, eraseGood
	ld	hl, strFailed
eraseGood:
	b_call(_PutS)
	b_call(_GetKey)
	ld	hl, mMainMenu
	jp	menu

;====== Term ===================================================================
quit:
	b_call(_ClrScrnFull)
	;b_call(_NewLine)
quitNoNewLine:
	B_CALL(_FlashWriteDisable)
	b_call(_HomeUp)
	set	indicRun, (iy+indicFlags)
	res	DonePrgm, (iy+DoneFlags)
	res	OnInterrupt, (iy+OnFlags)
	set	appAutoScroll, (iy+appFlags)
	;ld	sp, (spaddr)
	im	1
	ei
	ld	a, (sppage)
	out	(6), a
	ld	hl, (spaddr)
	jp	(hl)
	;ld	hl, (spaddr)
	;ret

#include "editor.asm"

#include "routines.asm"

#include "unlockflash.asm"

#include "data.asm"

.end
.end
